:
# RCSid:
#	$Id: source.sh,v 1.4 2022/09/06 16:58:20 sjg Exp $
#
#	@(#) Copyright (c) 1994-2021 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that
#	the above copyright notice and this notice are
#	left intact.
#
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

# this one can cause some shell's to segfault if loaded recursively
# so always use
# $_SOURCE_SH . source.sh
_SOURCE_SH=:

# these are from rc.sh, but others can use them too.
Which() {
    case "$1" in
    -*) t=$1; shift;;
    *) t=-x;;
    esac
    case "$1" in
    /*)	test $t $1 && echo $1;;
    *)
        for d in `IFS=:; echo ${2:-$PATH}`
	do
	    test $t $d/$1 && { echo $d/$1; break; }
	done
	;;
    esac
}

# We want to use local if we can
# if isposix-shell.sh has been sourced isPOSIX_SHELL will be set
case "$isPOSIX_SHELL" in
"") if (echo ${PATH%:*}) > /dev/null 2>&1; then
        local=local
    else
        local=:
    fi
    ;;
esac

dotted=
dot() {
    eval $local f

    for f in "$@"
    do
        if test -s $f; then
	    dotted="$dotted $f"
	    . $f
	fi
    done
}

dot_once() {
    local f

    for f in "$@"
    do
        case " $dotted " in
	*" $f "*) continue;;
	esac
	dot $f
    done
}

# handy for finding include files
_sourced_files=
_source() {
    local x f=$1; shift
    case $f in
    :|break) x=$f; f=$1; shift;;
    *) x=break;;
    esac
    for d in "" `IFS=:; echo ${*:-$PATH}`
    do
        test -s $d/$f || continue
        dot $d/$f
	$x
    done
    _sourced_files="$dotted"
}

source_all() { _source : "$@"; }
source_first() { _source "$@"; }
source_rc() { _source "$@"; }
case "`type source 2>&1`" in
*builtin*) ;;
*) source() { _source "$@"; };;
esac

case ./$0 in
*/source*) _source "$@";;
*/[wW]hich*) Which "$@";;
esac
